commit 821e48a3e49e602c06282a15813dfba9b99a206d
Author: Hans P. Schlaepfer <hanspeter.schlaepfer@revamp-it.ch>
Date:   Thu Jul 25 19:32:03 2019 +0200

    Neues Design 2019 Standard-Code templates/webpages/client_config/_warehouse.html

diff --git a/templates/webpages/client_config/_warehouse.html b/templates/webpages/client_config/_warehouse.html
index 162b85b08..52ae361ce 100644
--- a/templates/webpages/client_config/_warehouse.html
+++ b/templates/webpages/client_config/_warehouse.html
@@ -4,121 +4,90 @@
 [% USE T8 %]
 
 <div id="warehouse">
- <table>
-  <tr>
-   <td align="right">[% LxERP.t8('Default Transfer') %]</td>
-   <td>
-    [% L.yes_no_tag('defaults.transfer_default', SELF.defaults.transfer_default) %]
-   </td>
-   <td>
-    [% LxERP.t8('Show Transfer via default') %]<br>
-   </td>
-  </tr>
-  <tr>
-   <td align="right">[% LxERP.t8('Default Transfer with services') %]</td>
-   <td>
-    [% L.yes_no_tag('defaults.transfer_default_services', SELF.defaults.transfer_default_services) %]
-   </td>
-   <td>
-    [% LxERP.t8('Transfer services via default') %]<br>
-   </td>
-  </tr>
-  <tr>
-   <td align="right" nowrap="true">[% LxERP.t8('Default Warehouse') %]</td>
-   <td>
-    [% L.select_tag('defaults.warehouse_id', SELF.all_warehouses, id='warehouse_id', with_empty=1, default=SELF.defaults.warehouse_id, title_key='description',
-                    onchange="warehouse_selected(this.selectedIndex == 0 ? -1 : warehouses[this.selectedIndex - 1].id, -1)") %]
-   </td>
-   <td>
-    [% LxERP.t8('This is the default bin for parts') %]<br>
-    [% LxERP.t8('If configured this bin will be preselected for all new parts. Also this bin will be used as the master default bin, if default transfer out with master bin is activated.') %]<br>
-   </td>
-  </tr>
-  <tr>
-   <td align="right" nowrap="true">[% LxERP.t8('Default Bin') %]</td>
-   <td>[% L.select_tag('defaults.bin_id', [], id='bin_id', with_empty=1) %]</td>
-  </tr>
-  <tr>
-  <tr>
-   <td align="right">[% LxERP.t8('Default Transfer with Master Bin') %]</td>
-   <td>
-    [% L.yes_no_tag('defaults.transfer_default_use_master_default_bin', SELF.defaults.transfer_default_use_master_default_bin) %]
-   </td>
-   <td>
-    [% LxERP.t8('Use master default bin for Default Transfer, if no default bin for the part is configured') %]<br>
-   </td>
-  </tr>
-  <tr><td colspan="3"><hr /></td></tr>
-  <tr>
-   <td align="right">[% LxERP.t8('Default Transfer Out with negative inventory') %]</td>
-   <td>
-    [% L.yes_no_tag('defaults.transfer_default_ignore_onhand', SELF.defaults.transfer_default_ignore_onhand) %]
-   </td>
-   <td>
-    [% LxERP.t8('Default Transfer Out always succeed. The current part onhand is ignored and the inventory can have negative stocks (not recommended).') %]<br>
-   </td>
-  </tr>
+<div class="wrapper" id="wrapper-3">
 
- <tr>
-   <td align="right" nowrap="true">[% LxERP.t8('Default Warehouse with ignoring onhand') %]</td>
-   <td>
-    [% L.select_tag('defaults.warehouse_id_ignore_onhand', SELF.all_warehouses, id='warehouse_id_ignore_onhand', with_empty=1, default=SELF.defaults.warehouse_id_ignore_onhand, title_key='description',
-                    onchange="warehouse_selected(this.selectedIndex == 0 ? -1 : warehouses[this.selectedIndex - 1].id, -1, 'bin_id_ignore_onhand')") %]
-   </td>
-   <td>
-    [% LxERP.t8('This is the default warehouse for ignoring onhand') %]<br>
-   </td>
-  </tr>
-  <tr>
-   <td align="right" nowrap="true">[% LxERP.t8('Default Bin with ignoring onhand') %]</td>
-   <td>[% L.select_tag('defaults.bin_id_ignore_onhand', [], id='bin_id_ignore_onhand', with_empty=1) %]</td>
-   <td>[% LxERP.t8('If the default transfer out always succeed use this bin for negative stock quantity.') %]</td>
-  </tr>
-  <tr><td colspan="3"><hr /></td></tr>
-  <tr>
-   <td align="right">[% LxERP.t8('Transfer out on posting sales invoices?') %]</td>
-   <td>
-    [% L.yes_no_tag('defaults.is_transfer_out', SELF.defaults.is_transfer_out) %]
-   </td>
-   <td>
-   [% LxERP.t8('Transfer out all items of a sales invoice when posting it. Items are transfered out acording to the settings above.') %]
-   </td>
-  </tr>
-  <tr>
-   <td align="right">[% LxERP.t8('Match Sales Invoice Serial numbers with inventory charge numbers?') %]</td>
-   <td>
-    [% L.yes_no_tag('defaults.sales_serial_eq_charge', SELF.defaults.sales_serial_eq_charge) %]
-   </td>
-   <td>
-   [% LxERP.t8('If one or more space separated serial numbers are assigned in a sales invoice, match the charge number of the inventory item. Assumes that Serial Number and Charge Number have 1:1 relation. Otherwise throw a error message for the default sales invoice transfer.') %]
-   </td>
-  </tr>
+<table class="tbl-horizontal expanded">
+  <caption>[% 'Default Warehouse' | $T8 %]</caption>
+  <colgroup> <col class="wi-normal"><col class="wi-mediumsmall"><col class="wi-verywide"> </colgroup>
+  <tbody>
+    <tr>
+      <th>[% LxERP.t8('Default Transfer') %]</th>
+      <td>[% L.yes_no_tag('defaults.transfer_default', SELF.defaults.transfer_default, class='wi-small') %] </td>
+      <td class="long-desc"> [% LxERP.t8('Show Transfer via default') %]<br>
+      </td>
+    </tr>
+    <tr>
+      <th>[% LxERP.t8('Default Transfer with services') %]</th>
+      <td> [% L.yes_no_tag('defaults.transfer_default_services', SELF.defaults.transfer_default_services, class='wi-small') %] </td>
+      <td class="long-desc"> [% LxERP.t8('Transfer services via default') %]<br>
+      </td>
+    </tr>
+    <tr>
+      <th>[% LxERP.t8('Default Warehouse') %]</th>
+      <td> [% L.select_tag('defaults.warehouse_id', SELF.all_warehouses, id='warehouse_id', with_empty=1, default=SELF.defaults.warehouse_id, title_key='description', onchange="warehouse_selected(this.selectedIndex == 0 ? -1 : warehouses[this.selectedIndex - 1].id, -1)", class='wi-normal') %] </td>
+      <td class="long-desc"> [% LxERP.t8('This is the default bin for parts') %]<br>
+      [% LxERP.t8('If configured this bin will be preselected for all new parts. Also this bin will be used as the master default bin, if default transfer out with master bin is activated.') %]<br>
+      </td>
+    </tr>
+    <tr>
+      <th>[% LxERP.t8('Default Bin') %]</th>
+      <td>[% L.select_tag('defaults.bin_id', [], id='bin_id', with_empty=1, class='wi-normal') %]</td>
+      <td></td>
+    </tr>
+    <tr>
+      <th>[% LxERP.t8('Default Transfer with Master Bin') %]</th>
+      <td> [% L.yes_no_tag('defaults.transfer_default_use_master_default_bin', SELF.defaults.transfer_default_use_master_default_bin, class='wi-small') %] </td>
+      <td class="long-desc"> [% LxERP.t8('Use master default bin for Default Transfer, if no default bin for the part is configured') %]<br>
+      </td>
+    </tr>
+    <tr><th class="caption" colspan="3"> [% 'With Ignoring Onhand' | $T8 %] </th></tr>
+    <tr>
+      <th>[% LxERP.t8('Default Transfer Out with negative inventory') %]</th>
+      <td> [% L.yes_no_tag('defaults.transfer_default_ignore_onhand', SELF.defaults.transfer_default_ignore_onhand, class='wi-small') %] </td>
+      <td class="long-desc"> [% LxERP.t8('Default Transfer Out always succeed. The current part onhand is ignored and the inventory can have negative stocks (not recommended).') %]<br>
+      </td>
+    </tr>
+    <tr>
+      <th>[% LxERP.t8('Default Warehouse with ignoring onhand') %]</th>
+      <td> [% L.select_tag('defaults.warehouse_id_ignore_onhand', SELF.all_warehouses, id='warehouse_id_ignore_onhand', with_empty=1, default=SELF.defaults.warehouse_id_ignore_onhand, title_key='description', onchange="warehouse_selected(this.selectedIndex == 0 ? -1 : warehouses[this.selectedIndex - 1].id, -1, 'bin_id_ignore_onhand')", class='wi-normal') %] </td>
+      <td class="long-desc"> [% LxERP.t8('This is the default warehouse for ignoring onhand') %] </td>
+    </tr>
+    <tr>
+      <th>[% LxERP.t8('Default Bin with ignoring onhand') %]</th>
+      <td>[% L.select_tag('defaults.bin_id_ignore_onhand', [], id='bin_id_ignore_onhand', with_empty=1, class='wi-normal') %]</td>
+      <td class="long-desc">[% LxERP.t8('If the default transfer out always succeed use this bin for negative stock quantity.') %]</td>
+    </tr>
+    <tr><th class="caption" colspan="3"> [% 'Transfer Out & Assembly Transfer' | $T8 %] </th></tr>
+    <tr>
+      <th>[% LxERP.t8('Transfer out on posting sales invoices?') %]</th>
+      <td> [% L.yes_no_tag('defaults.is_transfer_out', SELF.defaults.is_transfer_out) %] </td>
+      <td class="long-desc"> [% LxERP.t8('Transfer out all items of a sales invoice when posting it. Items are transfered out acording to the settings above.') %] </td>
+    </tr>
+    <tr>
+     <th>[% LxERP.t8('Match Sales Invoice Serial numbers with inventory charge numbers?') %]</th>
+     <td>[% L.yes_no_tag('defaults.sales_serial_eq_charge', SELF.defaults.sales_serial_eq_charge) %]</td>
+     <td class="long-desc">[% LxERP.t8('If one or more space separated serial numbers are assigned in a sales invoice, match the charge number of the inventory item. Assumes that Serial Number and Charge Number have 1:1 relation. Otherwise throw a error message for the default sales invoice transfer.') %]</td>
+    </tr>
+    <tr>
+      <th>[% LxERP.t8('Use default warehouse for assembly transfer') %]</th>
+      <td> [% L.yes_no_tag('defaults.transfer_default_warehouse_for_assembly', SELF.defaults.transfer_default_warehouse_for_assembly) %] </td>
+      <td class="long-desc"> [% LxERP.t8('Transfer of assemblies uses the assembly\'s default warehouse instead of the destination warehouse.') %]<br>
+      </td>
+    </tr>
+    <tr><th class="caption" colspan="3"> [% 'Bestbefore' | $T8 %] </th></tr>
+    <tr>
+      <th>[% LxERP.t8('Show Bestbefore') %]</th>
+      <td> [% L.yes_no_tag('defaults.show_bestbefore', SELF.defaults.show_bestbefore) %] </td>
+      <td class="long-desc"> [% LxERP.t8('Show fields used for the best before date?') %]<br>
+      [% LxERP.t8('ATTENTION! If you enabled this feature you can not simply turn it off again without taking care that best_before fields are emptied in the database.') %]<br>
+      [% LxERP.t8('This can be done with the following query:') %]<br>
+      <br>
+      UPDATE inventory SET bestbefore = NULL; <br>
+      <br>
+      [% LxERP.t8('Any stock contents containing a best before date will be impossible to stock out otherwise.') %] </td>
+    </tr>
+  </tbody>
+</table>
 
-  <tr>
-   <td align="right">[% LxERP.t8('Use default warehouse for assembly transfer') %]</td>
-   <td>
-    [% L.yes_no_tag('defaults.transfer_default_warehouse_for_assembly', SELF.defaults.transfer_default_warehouse_for_assembly) %]
-   </td>
-   <td>
-    [% LxERP.t8('Transfer of assemblies uses the assembly\'s default warehouse instead of the destination warehouse.') %]<br>
-   </td>
-  </tr>
-  <tr><td colspan="3"><hr /></td></tr>
-  <tr>
-  <tr>
-   <td align="right">[% LxERP.t8('Show Bestbefore') %]</td>
-   <td>
-    [% L.yes_no_tag('defaults.show_bestbefore', SELF.defaults.show_bestbefore) %]
-   </td>
-   <td>
-    [% LxERP.t8('Show fields used for the best before date?') %]<br>
-    [% LxERP.t8('ATTENTION! If you enabled this feature you can not simply turn it off again without taking care that best_before fields are emptied in the database.') %]<br>
-    [% LxERP.t8('This can be done with the following query:') %]<br>
-    <br>
-    UPDATE inventory SET bestbefore = NULL; <br>
-    <br>
-    [% LxERP.t8('Any stock contents containing a best before date will be impossible to stock out otherwise.') %]
-   </td>
-  </tr>
- </table>
-</div>
+</div><!-- /.wrapper -->
+</div><!-- /#warehouse -->