commit 854f3716c06031004acf255c6f0b3d20b14e5574
Author: Hans P. Schlaepfer <hanspeter.schlaepfer@revamp-it.ch>
Date:   Mon Jul 29 16:03:48 2019 +0200

    Neues Design 2019 Standard-Code  templates/webpages/requirement_spec/_form.html

diff --git a/templates/webpages/requirement_spec/_form.html b/templates/webpages/requirement_spec/_form.html
index 38e532a3a..96b797414 100644
--- a/templates/webpages/requirement_spec/_form.html
+++ b/templates/webpages/requirement_spec/_form.html
@@ -1,75 +1,67 @@
-[%- DEFAULT id_prefix = 'basic_settings_form'
-            submit_as = 'post'
 [% USE LxERP %]
 [% USE L %]
 [% USE HTML %]
+[% 
+  DEFAULT id_prefix = 'basic_settings_form'
+          submit_as = 'post'
 %]
 <form method="post" action="controller.pl" id="[% id_prefix %]"[% UNLESS submit_as == 'post' %] class="edit-basic-settings-context-menu"[% END %]>
- <h2>[% LxERP.t8("Edit general settings") %]</h2>
+<div class="wrapper">
 
- [% L.hidden_tag("id", SELF.requirement_spec.id, id=id_prefix _ '_id') %]
- [% L.hidden_tag("requirement_spec.is_template", SELF.requirement_spec.is_template, id=id_prefix _ '_is_template') %]
+[% L.hidden_tag("id", SELF.requirement_spec.id, id=id_prefix _ '_id') %]
+[% L.hidden_tag("requirement_spec.is_template", SELF.requirement_spec.is_template, id=id_prefix _ '_is_template') %]
 
- <table class="rs_input_field">
-  <tr>
-   <td>[% LxERP.t8("Title") %]</td>
-   <td>[% L.input_tag("requirement_spec.title", SELF.requirement_spec.title, id=id_prefix _ '_title') %]</td>
-  </tr>
+<table class="tbl-horizontal rs_input_field">
+  <caption>[% LxERP.t8("Edit general settings") %]</caption>
+  <tbody>
+    <tr>
+     <th>[% LxERP.t8("Title") %]</th>
+     <td>[% L.input_tag("requirement_spec.title", SELF.requirement_spec.title, id=id_prefix _ '_title') %]</td>
+    </tr>
+    <tr>
+     <th>[% LxERP.t8("Requirement Spec Type") %]</th>
+     <td>[% L.select_tag("requirement_spec.type_id",  SELF.types, default=SELF.requirement_spec.type_id, title_key="description", id=id_prefix _ '_type_id') %]</td>
+    </tr>
+    [% UNLESS SELF.requirement_spec.is_template %]
+      <tr>
+       <th>[% LxERP.t8("Requirement Spec Status") %]</th>
+       <td>[% L.select_tag("requirement_spec.status_id",  SELF.statuses, default=SELF.requirement_spec.status_id, title_key="description", id=id_prefix _ '_status_id') %]</td>
+      </tr>
+      <tr>
+        <th>[% LxERP.t8("Customer") %]</th>
+        <td>[% 
+            L.select_tag("requirement_spec.customer_id",  SELF.customers, default=SELF.requirement_spec.customer_id, title_key="name", id=id_prefix _ '_customer_id',
+              onchange="kivi.requirement_spec.basic_settings_customer_changed('#" _ id_prefix _ "_customer_id', '#" _ id_prefix _ "_hourly_rate_as_number')") 
+        %]</td>
+      </tr>
+      <tr>
+        <th>[% LxERP.t8("Hourly Rate") %]</th>
+        <td>[% L.input_tag("requirement_spec.hourly_rate_as_number", SELF.requirement_spec.hourly_rate_as_number, id=id_prefix _ '_hourly_rate_as_number') %]</td>
+      </tr>
+    [% END %]
+    [% cvars = SELF.requirement_spec.cvars_by_config %]
+    [% FOREACH var = cvars %]
+      <tr>
+        <th>[% HTML.escape(var.config.description) %]</th>
+        <td>[% INCLUDE 'common/render_cvar_input.html'
+                        cvar_name_prefix = 'cvars.' %]</td>
+      </tr>
+    [% END %]
+  </tbody>
+</table>
 
-  <tr>
-   <td>[% LxERP.t8("Requirement Spec Type") %]</td>
-   <td>[% L.select_tag("requirement_spec.type_id",  SELF.types, default=SELF.requirement_spec.type_id, title_key="description", id=id_prefix _ '_type_id') %]</td>
-  </tr>
-
-[%- UNLESS SELF.requirement_spec.is_template %]
-
-  <tr>
-   <td>[% LxERP.t8("Requirement Spec Status") %]</td>
-   <td>[% L.select_tag("requirement_spec.status_id",  SELF.statuses, default=SELF.requirement_spec.status_id, title_key="description", id=id_prefix _ '_status_id') %]</td>
-  </tr>
-
-  <tr>
-   <td>[% LxERP.t8("Customer") %]</td>
-   <td>[% L.select_tag("requirement_spec.customer_id",  SELF.customers, default=SELF.requirement_spec.customer_id, title_key="name", id=id_prefix _ '_customer_id',
-                       onchange="kivi.requirement_spec.basic_settings_customer_changed('#" _ id_prefix _ "_customer_id', '#" _ id_prefix _ "_hourly_rate_as_number')") %]</td>
-  </tr>
-
-  <tr>
-   <td>[% LxERP.t8("Hourly Rate") %]</td>
-   <td>[% L.input_tag("requirement_spec.hourly_rate_as_number", SELF.requirement_spec.hourly_rate_as_number, id=id_prefix _ '_hourly_rate_as_number') %]</td>
-  </tr>
-
-[%- END %]
-
-  [% cvars = SELF.requirement_spec.cvars_by_config %]
-
-  [% FOREACH var = cvars %]
-   <tr>
-    <td>[% HTML.escape(var.config.description) %]</td>
-
-    <td>
-      [% INCLUDE 'common/render_cvar_input.html'
-                 cvar_name_prefix = 'cvars.'
-      %]
-    </td>
-   </tr>
-  [% END %]
-
- </table>
-
-[%- IF SELF.copy_source %]
- [%- L.hidden_tag('copy_source_id', SELF.copy_source.id) %]
-
- <p>
-  [%- IF SELF.requirement_spec.is_template %]
-   [%- LxERP.t8("The new requirement spec template will be a copy of '#1'.", SELF.copy_source.title) %]
-  [%- ELSE %]
-   [%- LxERP.t8("The new requirement spec will be a copy of '#1' for customer '#2'.", SELF.copy_source.title, SELF.copy_source.customer.name) %]
-  [%- END %]
- </p>
-[%- END %]
+[% IF SELF.copy_source %]
+  [% L.hidden_tag('copy_source_id', SELF.copy_source.id) %]
+  <p>
+    [% IF SELF.requirement_spec.is_template %]
+      [% LxERP.t8("The new requirement spec template will be a copy of '#1'.", SELF.copy_source.title) %]
+    [% ELSE %]
+      [% LxERP.t8("The new requirement spec will be a copy of '#1' for customer '#2'.", SELF.copy_source.title, SELF.copy_source.customer.name) %]
+    [% END %]
+  </p>
+[% END %]
 
- <p>
+<div class="buttons">
 [% IF submit_as != 'post' %]
   [% L.ajax_submit_tag("controller.pl?action=RequirementSpec/update",  "#" _ id_prefix, LxERP.t8("Save"), id=id_prefix _ '_submit') %]
   <script type="text/javascript"><!--
@@ -84,5 +76,6 @@
   });
 --></script>
 [% END %]
- </p>
+ </div><!-- /.buttons -->
+</div><!-- /.wrapper -->
 </form>