commit 7ebffd0dc904b3642c86c8fb67b8113e9c1ce983
Author: Moritz Bunkus <m.bunkus@linet.de>
Date:   Fri Mar 17 13:37:43 2017 +0100

    Menüvereinheitlichung: »Verkauf« → »Angebote/Aufträge« umgestellt

diff --git a/bin/mozilla/oe.pl b/bin/mozilla/oe.pl
index f19a2876c..ae16f65ff 100644
--- a/bin/mozilla/oe.pl
+++ b/bin/mozilla/oe.pl
@@ -441,6 +441,13 @@ sub setup_oe_search_action_bar {
         submit    => [ '#form' ],
         accesskey => 'enter',
       ],
+
+      'separator',
+
+      link => [
+        t8('Add'),
+        link => 'oe.pl?action=add&type=' . E($::form->{type}),
+      ],
     );
   }
 }
@@ -448,16 +455,25 @@ sub setup_oe_search_action_bar {
 sub setup_oe_orders_action_bar {
   my %params = @_;
 
-  return unless $::form->{type} eq 'sales_order';
-
   for my $bar ($::request->layout->get('actionbar')) {
     $bar->add(
-      action => [
-        t8('New sales order'),
-        submit    => [ '#form', { action => 'edit' } ],
-        checks    => [ [ 'kivi.check_if_entries_selected', '[name^=multi_id_]' ] ],
-        accesskey => 'enter',
-      ],
+      @{ $params{report_generator_actions} },
+
+      'separator',
+
+      combobox => [
+        link => [
+          t8('Add'),
+          link => 'oe.pl?action=add&type=' . E($::form->{type}),
+        ],
+
+        action => [
+          t8('Merge selected entries into new order'),
+          submit  => [ '#form', { action => 'edit' } ],
+          checks  => [ [ 'kivi.check_if_entries_selected', '[name^=multi_id_]' ] ],
+          only_if => $::form->{type} eq 'sales_order',
+        ],
+      ], # end of combobox "add"
     );
   }
 }
@@ -1266,8 +1282,7 @@ sub orders {
   $report->add_separator();
   $report->add_data(create_subtotal_row(\%totals, \@columns, \%column_alignment, \@subtotal_columns, 'listtotal'));
 
-  setup_oe_orders_action_bar();
-  $report->generate_with_headers();
+  $report->generate_with_headers(action_bar_setup_hook => sub { setup_oe_orders_action_bar(report_generator_actions => \@_) });
 
   $main::lxdebug->leave_sub();
 }
diff --git a/locale/de/all b/locale/de/all
index 41496079c..d7fa49eb2 100755
--- a/locale/de/all
+++ b/locale/de/all
@@ -168,15 +168,12 @@ $self->{texts} = {
   'Add Part'                    => 'Ware erfassen',
   'Add Price Factor'            => 'Preisfaktor erfassen',
   'Add Printer'                 => 'Drucker hinzufügen',
-  'Add Project'                 => 'Projekt erfassen',
   'Add Purchase Delivery Order' => 'Lieferschein (Einkauf) erfassen',
   'Add Purchase Order'          => 'Lieferantenauftrag erfassen',
   'Add Purchase Order (experimental)' => 'Lieferantenauftrag erfassen (experimentell)',
   'Add Quotation'               => 'Angebot erfassen',
   'Add RFQ'                     => 'Preisanfrage erfassen',
   'Add Request for Quotation'   => 'Anfrage erfassen',
-  'Add Requirement Spec'        => 'Pflichtenheft erfassen',
-  'Add Requirement Spec Template' => 'Pflichtenheftvorlage erfassen',
   'Add Sales Delivery Order'    => 'Lieferschein (Verkauf) erfassen',
   'Add Sales Invoice'           => 'Rechnung erfassen',
   'Add Sales Order'             => 'Auftrag erfassen',
@@ -1772,6 +1769,7 @@ $self->{texts} = {
   'Memo'                        => 'Memo',
   'Merchandise'                 => 'Handelsware',
   'Merchandise (typeabbreviation)' => 'H',
+  'Merge selected entries into new order' => 'Ausgewählte Einträge zu neuem Auftrag zusammenfassen',
   'Message'                     => 'Nachricht',
   'Method'                      => 'Verfahren',
   'Microfiche'                  => 'Mikrofilm',
@@ -1835,7 +1833,6 @@ $self->{texts} = {
   'New row, description'        => 'Neue Zeile, Artikelbeschreibung',
   'New row, partnumber'         => 'Neue Zeile, Nummer',
   'New row, qty'                => 'Neue Zeile, Menge',
-  'New sales order'             => 'Neuer Auftrag',
   'New shipto'                  => 'Neue Lieferadresse',
   'New window/tab'              => 'Neues Fenster/Tab',
   'Next Dunning Level'          => 'Nächste Mahnstufe',
diff --git a/menus/user/00-erp.yaml b/menus/user/00-erp.yaml
index e6c23d837..fe2a7c0c0 100644
--- a/menus/user/00-erp.yaml
+++ b/menus/user/00-erp.yaml
@@ -119,24 +119,24 @@
   params:
     action: RequirementSpec/list
 - parent: ar
-  id: ar_add_quotation
-  name: Add Quotation
-  icon: quotation_add
+  id: ar_quotations
+  name: Quotations
+  icon: report_quotations
   order: 200
   access: sales_quotation_edit
   module: oe.pl
   params:
-    action: add
+    action: search
     type: sales_quotation
 - parent: ar
-  id: ar_add_sales_order
-  name: Add Sales Order
-  icon: sales_order_add
+  id: ar_sales_orders
+  name: Sales Orders
+  icon: report_sales_orders
   order: 300
   access: sales_order_edit
   module: oe.pl
   params:
-    action: add
+    action: search
     type: sales_order
 - parent: ar
   id: ar_add_delivery_order
@@ -203,26 +203,6 @@
   name: Reports
   icon: ar_report
   order: 900
-- parent: ar_reports
-  id: ar_reports_quotations
-  name: Quotations
-  icon: report_quotations
-  order: 200
-  access: sales_quotation_edit
-  module: oe.pl
-  params:
-    action: search
-    type: sales_quotation
-- parent: ar_reports
-  id: ar_reports_sales_orders
-  name: Sales Orders
-  icon: report_sales_orders
-  order: 300
-  access: sales_order_edit
-  module: oe.pl
-  params:
-    action: search
-    type: sales_order
 - parent: ar_reports
   id: ar_reports_delivery_orders
   name: Delivery Orders