commit b0e933c22e7c0824042376d647e65e568f0c45d2
Author: Moritz Bunkus <m.bunkus@linet.de>
Date:   Fri Jan 19 09:50:54 2007 +0000

    Locale-Update... Ist wohl irgendwie verschwunden.

diff --git a/locale/de/all b/locale/de/all
index 281d093ff..d4a86883f 100644
--- a/locale/de/all
+++ b/locale/de/all
@@ -353,7 +353,7 @@ gestartet',
   'Dunnings'                    => 'Mahnungen',
   'E-mail'                      => 'eMail',
   'E-mail Statement to'         => 'Fälligkeitsabrechnung als eMail an',
-  'E-mail address missing!'     => '',
+  'E-mail address missing!'     => 'E-Mail-Adresse fehlt!',
   'E-mailed'                    => 'eMail gesendet.',
   'ELSTER Export (Taxbird)'     => 'ELSTER-Export nach Taxbird',
   'ELSTER Export (Winston)'     => 'ELSTER Export nach Winston',
diff --git a/locale/de/cn b/locale/de/cn
index f5ecf96a0..4f75a3bd5 100644
--- a/locale/de/cn
+++ b/locale/de/cn
@@ -57,7 +57,7 @@ $self->{texts} = {
   'Discount'                    => 'Rabatt',
   'Due Date'                    => 'Fälligkeitsdatum',
   'E-mail'                      => 'eMail',
-  'E-mail address missing!'     => 'E-mail address missing!',
+  'E-mail address missing!'     => 'E-Mail-Adresse fehlt!',
   'E-mailed'                    => 'eMail gesendet.',
   'Edit Credit Note'            => 'Gutschrift bearbeiten',
   'Enter longdescription'       => 'Langtext eingeben',
diff --git a/locale/de/dn b/locale/de/dn
index f6d33fcac..c298295ea 100644
--- a/locale/de/dn
+++ b/locale/de/dn
@@ -52,7 +52,7 @@ $self->{texts} = {
 gestartet',
   'Dunning overview'            => 'Mahnungsübersicht',
   'E-mail'                      => 'eMail',
-  'E-mail address missing!'     => 'E-mail address missing!',
+  'E-mail address missing!'     => 'E-Mail-Adresse fehlt!',
   'E-mailed'                    => 'eMail gesendet.',
   'Edit Dunning Process Config' => 'Mahnwesenkonfiguration bearbeiten',
   'Enter longdescription'       => 'Langtext eingeben',
diff --git a/locale/de/ic b/locale/de/ic
index acdd3abcc..79b33e878 100644
--- a/locale/de/ic
+++ b/locale/de/ic
@@ -54,7 +54,7 @@ aktualisieren wollen?',
   'Discount'                    => 'Rabatt',
   'Drawing'                     => 'Zeichnung',
   'E-mail'                      => 'eMail',
-  'E-mail address missing!'     => 'E-mail address missing!',
+  'E-mail address missing!'     => 'E-Mail-Adresse fehlt!',
   'E-mailed'                    => 'eMail gesendet.',
   'Edit '                       => 'Bearbeiten',
   'Edit Assembly'               => 'Erzeugnis bearbeiten',
diff --git a/locale/de/io b/locale/de/io
index 45a1bd2e1..a65b81c67 100644
--- a/locale/de/io
+++ b/locale/de/io
@@ -31,7 +31,7 @@ $self->{texts} = {
   'Department'                  => 'Abteilung',
   'Discount'                    => 'Rabatt',
   'E-mail'                      => 'eMail',
-  'E-mail address missing!'     => 'E-mail address missing!',
+  'E-mail address missing!'     => 'E-Mail-Adresse fehlt!',
   'E-mailed'                    => 'eMail gesendet.',
   'Enter longdescription'       => 'Langtext eingeben',
   'Extended'                    => 'Gesamt',
diff --git a/locale/de/ir b/locale/de/ir
index 2d6e2c4ed..45a65de0f 100644
--- a/locale/de/ir
+++ b/locale/de/ir
@@ -52,7 +52,7 @@ $self->{texts} = {
   'Discount'                    => 'Rabatt',
   'Due Date'                    => 'Fälligkeitsdatum',
   'E-mail'                      => 'eMail',
-  'E-mail address missing!'     => 'E-mail address missing!',
+  'E-mail address missing!'     => 'E-Mail-Adresse fehlt!',
   'E-mailed'                    => 'eMail gesendet.',
   'Edit Vendor Invoice'         => 'Einkaufsrechnung bearbeiten',
   'Enter longdescription'       => 'Langtext eingeben',
diff --git a/locale/de/is b/locale/de/is
index 995f000e1..ae71987a6 100644
--- a/locale/de/is
+++ b/locale/de/is
@@ -64,7 +64,7 @@ $self->{texts} = {
   'Due Date'                    => 'Fälligkeitsdatum',
   'Dunning Amount'              => 'gemahnter Betrag',
   'E-mail'                      => 'eMail',
-  'E-mail address missing!'     => 'E-mail address missing!',
+  'E-mail address missing!'     => 'E-Mail-Adresse fehlt!',
   'E-mailed'                    => 'eMail gesendet.',
   'Edit Credit Note'            => 'Gutschrift bearbeiten',
   'Edit Sales Invoice'          => 'Rechnung bearbeiten',
diff --git a/locale/de/oe b/locale/de/oe
index b60e43c38..ceb08f57c 100644
--- a/locale/de/oe
+++ b/locale/de/oe
@@ -70,7 +70,7 @@ $self->{texts} = {
   'Done'                        => 'Fertig',
   'Dunning Amount'              => 'gemahnter Betrag',
   'E-mail'                      => 'eMail',
-  'E-mail address missing!'     => 'E-mail address missing!',
+  'E-mail address missing!'     => 'E-Mail-Adresse fehlt!',
   'E-mailed'                    => 'eMail gesendet.',
   'Edit Purchase Order'         => 'Lieferantenaufrag bearbeiten',
   'Edit Quotation'              => 'Angebot bearbeiten',