commit 8ec3c8a993a578f1a8964202b2c6b20d2251c090
Author: Hans P. Schlaepfer <hanspeter.schlaepfer@revamp-it.ch>
Date:   Sun Jul 28 17:06:20 2019 +0200

    Neues Design 2019 Standard-Code

diff --git a/templates/webpages/acctranscorrections/assistant_for_wrong_taxes.html b/templates/webpages/acctranscorrections/assistant_for_wrong_taxes.html
index 791d59f25..007f0285c 100644
--- a/templates/webpages/acctranscorrections/assistant_for_wrong_taxes.html
+++ b/templates/webpages/acctranscorrections/assistant_for_wrong_taxes.html
@@ -4,7 +4,6 @@
 
 <h1>[% title %]</h1>
 
- <p>[% 'At the moment the transaction looks like this:' | $T8 %]</p>
 <p>[% 'The following transaction contains wrong taxes:' | $T8 %] <a href="[% problem.link %]">
 [% IF problem.data.module == 'ar'    %][% 'AR Transaction'             | $T8 %]
 [% ELSIF problem.data.module == 'ap' %][% 'AP Transaction'             | $T8 %]
@@ -12,60 +11,54 @@
 [% HTML.escape(problem.data.reference) %]
 </a></p>
 
- <p>
-  <table>
-   <tr>
-    <th class="listheading">[% 'Account' | $T8 %]</th>
-    <th class="listheading">[% 'Debit' | $T8 %]</th>
-    <th class="listheading">[% 'Credit' | $T8 %]</th>
-    <th class="listheading">[% 'Taxkey' | $T8 %]</th>
-    <th class="listheading">[% 'Recorded Tax' | $T8 %]</th>
-    <th class="listheading">[% 'Expected Tax' | $T8 %]</th>
-    <th class="listheading"></th>
-   </tr>
+<p>[% 'At the moment the transaction looks like this:' | $T8 %]</p>
 
-   [%- SET curr_row = 0 %]
-   [%- IF problem.acc_trans.credit.entries.size > problem.acc_trans.debit.entries.size %]
-    [%- SET order = [ 'credit', 'debit' ] %]
-    [%- SET other_side = 'debit' %]
-   [%- ELSE %]
-    [%- SET order = [ 'debit', 'credit' ] %]
-    [%- SET other_side = 'credit' %]
-   [%- END %]
+<table class="tbl-List">
+<thead>
+  <tr>
+    <th>[% 'Account' | $T8 %]</th>
+    <th>[% 'Debit' | $T8 %]</th>
+    <th>[% 'Credit' | $T8 %]</th>
+    <th>[% 'Taxkey' | $T8 %]</th>
+    <th>[% 'Recorded Tax' | $T8 %]</th>
+    <th>[% 'Expected Tax' | $T8 %]</th>
+    <th></th>
+  </tr>
+</thead>
 
-   [%- FOREACH idx = order %]
-    [%- FOREACH row = problem.acc_trans.$idx.entries %]
-     [%- SET curr_row = curr_row + 1 %]
-     <tr class="listrow[% curr_row % 2 %]">
-      <td>[% HTML.escape(row.accno) %]--[% HTML.escape(row.chartdescription) %]</td>
-      <td align="right">
-       [%- IF idx == 'debit' %]
-        [% LxERP.format_amount(row.display_amount, 2) %]
-       [%- END %]
-      </td>
-      <td align="right">
-       [%- IF idx == 'credit' %]
-        [% LxERP.format_amount(row.display_amount, 2) %]
-       [%- END %]
-      </td>
-      <td>[% IF idx != other_side %][% HTML.escape(row.taxdescription) %][% END %]</td>
-      <td align="right">[% IF row.actual_tax %][% LxERP.format_amount(row.actual_tax, 2) %][% END %]</td>
-      <td align="right">[% IF row.expected_tax %][% LxERP.format_amount(row.expected_tax, 2) %][% END %]</td>
-      <td align="center" valign="center"><img src="image/[% IF row.tax_error %]error[% ELSE %]ok[% END %].png"></td>
-     </tr>
-    [%- END %]
-   [%- END %]
+[% SET curr_row = 0 %]
+[% IF problem.acc_trans.credit.entries.size > problem.acc_trans.debit.entries.size %]
+  [% SET order = [ 'credit', 'debit' ] %]
+  [% SET other_side = 'debit' %]
+[% ELSE %]
+  [% SET order = [ 'debit', 'credit' ] %]
+  [% SET other_side = 'credit' %]
+[% END %]
 
-  </table>
- </p>
- <hr>
+<tbody>
+  [% FOREACH idx = order %]
+    [% FOREACH row = problem.acc_trans.$idx.entries %]
+      [% SET curr_row = curr_row + 1 %]
+      <tr class="listrow[% curr_row % 2 %]">
+        <td>[% HTML.escape(row.accno) %]--[% HTML.escape(row.chartdescription) %]</td>
+        <td>[% IF idx == 'debit'    %][% LxERP.format_amount(row.display_amount, 2) %][% END %]</td>
+        <td>[% IF idx == 'credit'   %][% LxERP.format_amount(row.display_amount, 2) %][% END %]</td>
+        <td>[% IF idx != other_side %][% HTML.escape(row.taxdescription)            %][% END %]</td>
+        <td>[% IF row.actual_tax    %][% LxERP.format_amount(row.actual_tax, 2)     %][% END %]</td>
+        <td>[% IF row.expected_tax  %][% LxERP.format_amount(row.expected_tax, 2)   %][% END %]</td>
+        <td><img src="image/[% IF row.tax_error %]error[% ELSE %]ok[% END %].png"></td>
+      </tr>
+    [% END %]
+  [% END %]
+</tbody>
+</table>
 
- <form method="post" action="acctranscorrections.pl">
-  <p>
-   <input type="hidden" name="action" value="delete_transaction">
-   <input type="hidden" name="trans_id" value="[% HTML.escape(problem.data.trans_id) %]">
-   <input type="submit" class="submit" value="[% 'Delete transaction' | $T8 %]">
-   <input type="button" class="submit" onclick="history.back()" value="[% 'Back' | $T8 %]">
-  </p>
- </form>
+<form method="post" action="acctranscorrections.pl">
+  <div class="buttons">
+    <input type="hidden" name="action" value="delete_transaction">
+    <input type="hidden" name="trans_id" value="[% HTML.escape(problem.data.trans_id) %]">
+    <input type="submit" value="[% 'Delete transaction' | $T8 %]">
+    <input type="button" onclick="history.back()" value="[% 'Back' | $T8 %]">
+  </div>
+</form>
 
diff --git a/templates/webpages/acctranscorrections/assistant_for_wrong_taxkeys.html b/templates/webpages/acctranscorrections/assistant_for_wrong_taxkeys.html
index e3225b519..0b3d4d596 100644
--- a/templates/webpages/acctranscorrections/assistant_for_wrong_taxkeys.html
+++ b/templates/webpages/acctranscorrections/assistant_for_wrong_taxkeys.html
@@ -11,112 +11,100 @@
 [% HTML.escape(problem.data.reference) %]
 </a></p>
 
+<p>
   [% 'This could have happened for two reasons:' | $T8 %]
-
   [% 'The first reason is that kivitendo contained a bug which resulted in the wrong taxkeys being recorded for transactions in which two entries are posted for the same chart with different taxkeys.' | $T8 %]
-
   [% 'The second reason is that kivitendo allowed the user to enter the tax amount manually regardless of the taxkey used.' | $T8 %]
-
   [% 'The third reason is that wrong (taxkey) settings for the credit / debit CSV-import were used.' | $T8 %]
-
   [% 'Such entries cannot be exported into the DATEV format and have to be fixed as well.' | $T8 %]
- </p>
-
- <p>
+</p>
+<p>
   [% 'The transaction is shown below in its current state.' | $T8 %]
-
   [% 'You can correct this transaction by chosing the correct taxkeys from the drop down boxes and hitting the button "Fix transaction" afterwards.' | $T8 %]
-
-  [%- 'It is possible that even after such a correction there is something wrong with this transaction (e.g. taxes that don\'t match the selected taxkey). Therefore you should re-run the general ledger analysis.' | $T8 %]
- </p>
-
- <p>
+  [% 'It is possible that even after such a correction there is something wrong with this transaction (e.g. taxes that don\'t match the selected taxkey). Therefore you should re-run the general ledger analysis.' | $T8 %]
+</p>
+<p>
   [% 'You can also delete this transaction and re-enter it manually.' | $T8 %]
-
   [% 'In order to do that hit the button "Delete transaction".' | $T8 %]
- </p>
-
- <p>[% 'At the moment the transaction looks like this:' | $T8 %]</p>
+</p>
+<p>[% 'At the moment the transaction looks like this:' | $T8 %]</p>
 
  <form method="post" action="acctranscorrections.pl" name="Form">
-  <p>
    <table>
     <tr>
-     <th class="listheading">[% 'Account' | $T8 %]</th>
-     <th class="listheading">[% 'Debit' | $T8 %]</th>
-     <th class="listheading">[% 'Credit' | $T8 %]</th>
-     <th class="listheading">[% 'Recorded Tax' | $T8 %]</th>
-     <th class="listheading">[% 'Recorded taxkey' | $T8 %]</th>
-     <th class="listheading">[% 'Expected Tax' | $T8 %]</th>
-     <th class="listheading"></th>
-     <th class="listheading">[% 'Correct taxkey' | $T8 %]</th>
+     <th>[% 'Account' | $T8 %]</th>
+     <th>[% 'Debit' | $T8 %]</th>
+     <th>[% 'Credit' | $T8 %]</th>
+     <th>[% 'Recorded Tax' | $T8 %]</th>
+     <th>[% 'Recorded taxkey' | $T8 %]</th>
+     <th>[% 'Expected Tax' | $T8 %]</th>
+     <th></th>
+     <th>[% 'Correct taxkey' | $T8 %]</th>
     </tr>
 
-    [%- SET curr_row = 0 %]
-    [%- IF (problem.data.module == 'ar') || ((problem.data.module == 'gl') && (problem.acc_trans.credit.entries.first.acc_trans_id < problem.acc_trans.debit.entries.first.acc_trans_id)) %]
-     [%- SET order = [ 'credit', 'debit' ] %]
-     [%- SET other_side = 'debit' %]
-    [%- ELSE %]
-     [%- SET order = [ 'debit', 'credit' ] %]
-     [%- SET other_side = 'credit' %]
-    [%- END %]
+    [% SET curr_row = 0 %]
+    [% IF (problem.data.module == 'ar') || ((problem.data.module == 'gl') && (problem.acc_trans.credit.entries.first.acc_trans_id < problem.acc_trans.debit.entries.first.acc_trans_id)) %]
+     [% SET order = [ 'credit', 'debit' ] %]
+     [% SET other_side = 'debit' %]
+    [% ELSE %]
+     [% SET order = [ 'debit', 'credit' ] %]
+     [% SET other_side = 'credit' %]
+    [% END %]
 
 
-    [%- IF problem.acc_trans.credit.entries.size > problem.acc_trans.debit.entries.size %]
-    [%- ELSE %]
-    [%- END %]
+    [% IF problem.acc_trans.credit.entries.size > problem.acc_trans.debit.entries.size %]
+    [% ELSE %]
+    [% END %]
 
 
-    [%- FOREACH idx = order %]
-     [%- FOREACH row = problem.acc_trans.$idx.entries %]
-      [%- SET curr_row = curr_row + 1 %]
+    [% FOREACH idx = order %]
+     [% FOREACH row = problem.acc_trans.$idx.entries %]
+      [% SET curr_row = curr_row + 1 %]
       <tr class="listrow[% curr_row % 2 %]">
        <td>[% HTML.escape(row.accno) %]--[% HTML.escape(row.chartdescription) %]</td>
-       <td align="right">
-        [%- IF idx == 'debit' %]
+       <td>
+        [% IF idx == 'debit' %]
          [% LxERP.format_amount(row.display_amount, 2) %]
-        [%- END %]
+        [% END %]
        </td>
-       <td align="right">
-        [%- IF idx == 'credit' %]
+       <td>
+        [% IF idx == 'credit' %]
          [% LxERP.format_amount(row.display_amount, 2) %]
-        [%- END %]
+        [% END %]
        </td>
-       <td align="right">[% IF row.actual_tax %][% LxERP.format_amount(row.display_actual_tax, 2) %][% END %]</td>
+       <td>[% IF row.actual_tax %][% LxERP.format_amount(row.display_actual_tax, 2) %][% END %]</td>
        <td>[% IF (problem.data.module == 'gl') || (idx != other_side) %][% HTML.escape(row.taxdescription) %][% END %]</td>
-       <td align="right">[% IF row.expected_tax %][% LxERP.format_amount(row.display_expected_tax, 2) %][% END %]</td>
-       <td align="center" valign="center"><img src="image/[% IF row.taxkey_error %]error[% ELSE %]ok[% END %].png"></td>
+       <td>[% IF row.expected_tax %][% LxERP.format_amount(row.display_expected_tax, 2) %][% END %]</td>
+       <td><img src="image/[% IF row.taxkey_error %]error[% ELSE %]ok[% END %].png"></td>
 
        <td>
-        [%- IF row.taxkey_error %]
+        [% IF row.taxkey_error %]
          <input type="hidden" name="fixes[+].acc_trans_id" value="[% HTML.escape(row.acc_trans_id) %]">
          <input type="hidden" name="fixes[].tax_entry_acc_trans_id" value="[% HTML.escape(row.tax_entry_acc_trans_id) %]">
          <select name="fixes[].taxkey" style="width: 250px" onchange="enable_fix_button_maybe()">
           <option value="">[% '---please select---' | $T8 %]</option>
-          [%- FOREACH taxkey = row.correct_taxkeys %]
+          [% FOREACH taxkey = row.correct_taxkeys %]
            <option value="[% HTML.escape(taxkey.taxkey) %]">[% HTML.escape(taxkey.description) %]</option>
-          [%- END %]
-        [%- ELSE %]
+          [% END %]
+        [% ELSE %]
         &nbsp;
-        [%- END %]
+        [% END %]
       </tr>
-     [%- END %]
-    [%- END %]
+     [% END %]
+    [% END %]
 
    </table>
-  </p>
   <hr>
 
   <p>
    <input type="hidden" name="callback" value="[% HTML.escape(callback) %]">
-
    <input type="hidden" name="action" value="dispatcher">
    <input type="hidden" name="trans_id" value="[% HTML.escape(problem.data.trans_id) %]">
    <input type="hidden" name="module" value="[% HTML.escape(problem.data.module) %]">
    <input type="hidden" name="reference" value="[% HTML.escape(problem.data.reference) %]">
-   <input type="submit" class="submit" id="fix_transaction_button" name="action_fix_wrong_taxkeys" value="[% 'Fix transaction' | $T8 %]" disabled>
-   <input type="submit" class="submit" name="action_delete_transaction" value="[% 'Delete transaction' | $T8 %]">
-   <input type="button" class="submit" onclick="history.back()" value="[% 'Back' | $T8 %]">
+   <input type="submit" id="fix_transaction_button" name="action_fix_wrong_taxkeys" value="[% 'Fix transaction' | $T8 %]" disabled>
+   <input type="submit" name="action_delete_transaction" value="[% 'Delete transaction' | $T8 %]">
+   <input type="button" onclick="history.back()" value="[% 'Back' | $T8 %]">
   </p>
  </form>
 